      complex function ctan (z)
c march 1979 edition.  w. fullerton, c3, los alamos scientific lab.
      complex z
      external alog, cos, cosh, r1mach, sin, sinh, sqrt, tanh
      data eps, xmax, ylarge, ybig, ymin / 4*0.0, 1.50 /
c
      if (eps.ne.0.0) go to 10
      eps =  r1mach(4)
      xmax = 1.0/eps
      ylarge = -0.5*alog(0.5*r1mach(3))
      ybig = -0.5*alog(0.5*sqrt(r1mach(3)))
c
 10   x = real(z)
      y = aimag(z)
      if (abs(y).gt.ylarge) go to 30
c
      x2 = 2.0*x
      y2 = 2.0*y
      if (abs(x2).gt.xmax) go to 20
c
      call entsrc (irold, 1)
      sn2x = sin(x2)
      call erroff
      den = cos(x2) + cosh(y2)
      call erroff
      call entsrc (irold2, irold)
c
      if (den.lt.x*x2*eps*eps) call seteru ( 72hctan    tan is nearly si
     1ngular, x is near pi/2 or 3*pi/2 and y is near 0, 72, 3, 2)
      if (den.lt.x*x2*eps) call seteru (74hctan    answer lt half precis
     1ion, x is near pi/2 or 3*pi/2 and y is near 0, 74, 1, 1)
c
      ctan = cmplx (sn2x/den, sinh(y2)/den)
      return
c
 20   if (abs(y).lt.ymin) call seteru (75hctan    answer would have no p
     1recision, abs(x) is very big and abs(y) small, 75, 4, 2)
      if (abs(y).lt.ybig) call seteru (69hctan    answer lt half precisi
     1on, abs(x) is very big and abs(y) small, 69, 2, 1)
c
      ctan = cmplx (0.0, tanh(y2))
      return
c
 30   ctan = cmplx (0.0, -sign(1.0, y))
      return
c
      end
